/* Copyright (C) 2004 - 2007  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
package com.db4o.internal;

import com.db4o.*;
import com.db4o.config.*;
import com.db4o.ext.*;


public class ObjectContainerFactory {
	
	public static ObjectContainer openObjectContainer(Configuration config,String databaseFileName) {
		
		ObjectContainer oc = null;
		
		if (Deploy.debug) {
			System.out.println("db4o Debug is ON");
			if (!Deploy.flush) {
				System.out.println("Debug option set NOT to flush file.");
			}
		}
		try {
			oc = new IoAdaptedObjectContainer(config,databaseFileName);				
		} catch (DatabaseFileLockedException e) {
			throw e;
		} catch (ObjectNotStorableException e) {
			throw e;
		} catch (Db4oException e) {
			throw e;
		} catch (Exception ex) {
			Messages.logErr(Db4o.configure(), 4, databaseFileName, ex);
			if(Deploy.debug){
				ex.printStackTrace();
			}
			return null;
		}
			
		Platform4.postOpen(oc);
		Messages.logMsg(Db4o.configure(), 5, databaseFileName);
		return oc;
	}
	
	

	
}
