/* Copyright (C) 2004 - 2007  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
package com.db4o.internal.marshall;

import com.db4o.*;
import com.db4o.internal.*;
import com.db4o.internal.query.processor.*;

/**
 * @exclude
 */
public abstract class UntypedMarshaller {
    
    MarshallerFamily _family;
    
    public abstract void deleteEmbedded(StatefulBuffer reader);
    
    public abstract Object writeNew(Object obj, boolean restoreLinkOffset, StatefulBuffer writer);

    public abstract Object read(StatefulBuffer reader) throws CorruptionException;
    
    public abstract TypeHandler4 readArrayHandler(Transaction a_trans, Buffer[] a_bytes);

    public abstract boolean useNormalClassRead();
    
    public abstract Object readQuery(Transaction trans, Buffer reader, boolean toArray) throws CorruptionException;

    public abstract QCandidate readSubCandidate(Buffer reader, QCandidates candidates, boolean withIndirection);

	public abstract void defrag(ReaderPair readers);
}
